package tcc;



import javax.naming.Context;
import javax.naming.InitialContext;

import tcc.portal.PortalServer;

 /**
  *Copyright &copy; 2006, Atomikos. All rights reserved.
  *
  *A demo client for the portal server example.
  */

public class Client
{
      
      public static void test ( String server ) 
      throws Exception
      {
            Context ctx = null;
            PortalServer pserver = null;
            String cardno = "card10";
            int itemId = 20;
            int qty = 2;
            int purchased = 0;
            int stock = 0;
            int previousStock = 0;

 
            ctx = new InitialContext();
            
           
            System.out.println ( "Looking up server..." );
            pserver = ( PortalServer ) ctx.lookup ( server );
            if ( pserver == null )
                throw new Exception ( "PortalServer not running?" );
            System.out.println ( "Server found!" );
            
            //first, get the initial stock
            System.out.println ( "Getting initial stock of item " + itemId + "..." );
            stock = pserver.getStock ( itemId );
            previousStock = stock;
            System.out.println ( "Initial stock is: " + stock );
            
            //get the amount purchased, just for fun
            System.out.println ( "Getting initial amount purchased..." );
            purchased = pserver.getAmountPurchased ( cardno );
            System.out.println ( "Amount purchased is: " + purchased );
            
            //purchase a qty; this should decrease stock by qty
            System.out.println ( "Purchasing " + qty + " of item " + itemId + " with card " + cardno + "..." );
            pserver.purchase ( cardno , itemId , qty );
            System.out.println ( "Purchase OK.");
            
            //check that purchase really worked as it should
            System.out.println ( "Getting new stock of item " + itemId + "..." );
            stock = pserver.getStock ( itemId );
            System.out.println ( "New is: " + stock );
            if (  ( previousStock - stock ) != qty )
                throw new Exception ( "Error: purchase does not work?" );
                
            
            //get amount just for fun
            System.out.println ( "Getting new amount purchased..." );
            purchased = pserver.getAmountPurchased ( cardno );
            System.out.println ( "Amount purchased is: " + purchased );

            //get amount just for fun
            purchased = pserver.getAmountPurchased ( cardno );            
      }

      public static void main ( String[] args ) 
      {
          String server = "";
          
          if ( args.length != 1 ) {
              System.err.println ( "Argument required: RMI URL of PortalServer" );
              System.exit ( 1 );  
          }
          server = args[0];
         
          
          try {
              System.out.println ( "Starting test..." );
              test ( server ); 
          }
          catch ( Exception e ) {
              e.printStackTrace(); 
          }
          finally {
              System.out.println ( "Test done!" ); 
          }
          
      }  
}
