package payment;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import tcc.MockedTccServiceManager;

import junit.framework.TestCase;

public class PaymentTccServiceTestJUnit extends TestCase 
{

	private PaymentTccService service;
	private String id;
	
	public PaymentTccServiceTestJUnit ( String name )
	{
		super ( name );
	}
	
	protected void setUp() throws Exception 
	{
		PaymentDbUtils.createDatabase();
		MockedTccServiceManager tccmgr = new MockedTccServiceManager();
		service = new PaymentTccService ( tccmgr , 1000 );
		service.tryPayment ( "TESTCARD" , 100 );
		id = tccmgr.getLastId();
	}
	

	private void assertDatabaseState ( String state )
	throws Exception
	{
		Connection c = PaymentDbUtils.getConnection();
		Statement s = c.createStatement();
		ResultSet rs = s.executeQuery ( "select * from PAYMENTS where key='" + id + "' and status ='"+state+"'" );
		if ( ! rs.next() ) fail ( "Not found: " + id );
		c.close();
	}

	public void testTryPayment() throws Exception
	{
		assertDatabaseState ( "PENDING" );
	}
	
	public void testConfirm() throws Exception 
	{
		service.confirm ( id );
		service.confirm ( id );
		assertDatabaseState ( "CONFIRMED");
	}

	public void testCancel() throws Exception 
	{
		service.cancel ( id );
		service.cancel ( id );
		assertDatabaseState ( "CANCELED");
	}
	


	public void testRecover() 
	{
		assertFalse ( service.recover ( "randomid" ) );
		assertTrue ( service.recover ( id ) );
	}

}
