package portal;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import junit.framework.TestCase;
import tcc.MockedTccServiceManager;

public class PortalTccServiceTestJUnit extends TestCase 
{

	private PortalTccService service;
	private String id;
	
	public PortalTccServiceTestJUnit ( String name )
	{
		super ( name );
	}
	
	protected void setUp() throws Exception 
	{
		PortalDbUtils.createDatabase();
		MockedTccServiceManager tccmgr = new MockedTccServiceManager();
		service = new PortalTccService ( tccmgr , 1000 );
		service.tryPurchase ( 10 , 100 );
		id = tccmgr.getLastId();
	}
	

	private void assertDatabaseState ( String state )
	throws Exception
	{
		Connection c = PortalDbUtils.getConnection();
		Statement s = c.createStatement();
		ResultSet rs = s.executeQuery ( "select * from PURCHASES where key='" + id + "' and status ='"+state+"'" );
		if ( ! rs.next() ) fail ( "Not found: " + id );
		c.close();
	}

	public void testTryPayment() throws Exception
	{
		assertDatabaseState ( "PENDING" );
	}
	
	public void testConfirm() throws Exception 
	{
		service.confirm ( id );
		service.confirm ( id );
		assertDatabaseState ( "CONFIRMED");
	}

	public void testCancel() throws Exception 
	{
		service.cancel ( id );
		service.cancel ( id );
		assertDatabaseState ( "CANCELED");
	}
	


	public void testRecover() 
	{
		assertFalse ( service.recover ( "randomid" ) );
		assertTrue ( service.recover ( id ) );
	}

}
